#! /bin/sh
EPELLE=LIB_DIR
BINDIR=BIN_DIR
USAGE="Usage: epelle [-tex] [-latex] [-8bit] [file] [-d dictionary] [-v] [-e env]"
DICT=$EPELLE/french.z
OPTION="-nw"

if [ -n "${DICOPLUS}" ]
then if [ -f $DICOPLUS ]
     then 
	BASENAME=`basename $DICOPLUS`
	case $BASENAME in
	  *.z)	TABLEPLUS=$DICOPLUS ;;
	  *)
		TABLEPLUS=$HOME/${BASENAME}.z
		make -f $EPELLE/Makefile EPELLE=$EPELLE TABLE=$BASENAME \
     		  TABLEPLUS=$TABLEPLUS HOME=$HOME DICOPLUS=$DICOPLUS ${TABLEPLUS} > /dev/null ;;
	esac
	PLUS="$BINDIR/zpellout $TABLEPLUS"
     else echo "The file $""DICOPLUS=$DICOPLUS does not exist"
          exit 1
     fi
fi
case $# in
	0) TYPE=troff; FILE="$1";;
	*) while test x$1 != x
		do
		    case $1 in
			-8bit) LC_CTYPE=iso_8859_1;;
			-tex) TYPE=tex;;
			-latex) TYPE=tex; OPTION="$OPTION -l";;
			-d|-dict*)
				shift ; DICT=$1 
				if [ ! -r $DICT ]
				then echo "Could not find dictionary: $DICT."
	     			exit 2 ; fi;;
			-v) echo "Epelle version 2.2 (Jan 96)"
			    exit 0;;
			-e) shift ; OPTION="$OPTION -e $1";;
			-*) echo 'Incorrect option:' "$1"
                            echo $USAGE
                            exit 1;;
			*) FILE="$1";;
		    esac
		    shift
		done;;
esac
case "${LC_CTYPE}" in
	"") case $TYPE in
		tex) $BINDIR/detex $OPTION < $FILE | sort -u | $BINDIR/zpellout ${DICT} | ${PLUS-cat};;
		*) $BINDIR/words < $FILE | sort -u | $BINDIR/zpellout ${DICT} | ${PLUS-cat};;
	    esac;;
	*) case $TYPE in
		tex) $BINDIR/detex $OPTION < $FILE | sort -u | $BINDIR/zpellout ${DICT} | ${PLUS-cat} | sed -f $EPELLE/troff2latin.sed;;
		*) sed -f $EPELLE/latin2troff.sed < $FILE | $BINDIR/words | sort -u | $BINDIR/zpellout ${DICT} | ${PLUS-cat} | sed -f $EPELLE/troff2latin.sed;;
	   esac;;
esac

