/* zpellout table < liste_mots > mots_errone's */

#include "epelle.h"

#define MAXLENGTH 256                   /* longueur maxi des mots */
#define CTOI(a) ((a<0) ? a+256 : a)

typedef struct NOEUD {
    char c,existe;
    unsigned int fils,frere;
} noeud;

noeud T[MAX_NODES];
int racine;

main(argc,argv)
int argc;
char* argv[];
{
    FILE *f,*fopen();
    char c,mot[MAXLENGTH],c1,c2;
    int i=0,rev;

    rev = (argc>2) ? 1 : 0;
    /* entre'e de la table */
#ifndef MSDOS
    f = fopen(argv[1+rev],"r");
#else
    f = fopen(argv[1+rev],"rb");
#endif
    while ((c = getc(f)) != (char)EOF) {
	T[++i].c = c;
	c =  getc(f);
	T[i].existe = I(c) & 0x1;
	c1 = getc(f); c2 = getc(f);
	T[i].fils = CTOI(c1) + (CTOI(c2) << 8);
	c1 = getc(f); c2 = getc(f);
	T[i].frere = CTOI(c1) + (CTOI(c2) << 8);
	T[i].fils += (I(c) & 0xE) << 15;
	T[i].frere += (I(c) & 0x70) << 12;
    }
    racine = i;

    /* boucle de de'tection de mots errone's */
    i = 0;
    while ((c = getchar()) != (char)EOF)
	if ((unsigned)c>' ') mot[i++] = c;
	else { 
	    mot[i] = 0; 
	    /* un mot est accepte' lorsqu'en mettant toutes ses lettres
	       en minuscules, on trouve un mot du dictionnaire */
	    if (valide(mot)==rev) printf("%s\n",mot);
	    i = 0;
	    }
    exit(0);
}

int valide(s)
char *s;
{
    int i,t;
    char c;

    i=0; t=racine;
    while ((c = tolower(s[i])) != 0) {
	if (T[t].fils == 0) return(0); /* non valide */
	t = T[t].fils;
	while (T[t].c != c) {
	    if (T[t].frere == 0) return(0); /* non valide */
	    else t = T[t].frere;
	}
	i++;
    }
    return(I(T[t].existe)); /* 0 ou 1 */
}
